function J =objectivefunctionC(search_scalar,femmodel,n);
%OBJECTIVEFUNCTIONC - objective function that return a parameter for a certain function

conserve_loads=true;
%recover some parameters
optscal=femmodel.parameters.OptScal(n);
fit=femmodel.parameters.Fit(n);
control_type=femmodel.parameters.ControlType;
control_steady=femmodel.parameters.ControlSteady;
analysis_type=femmodel.parameters.AnalysisType;
isstokes=femmodel.parameters.IsStokes;
cm_min=femmodel.parameters.CmMin;
cm_max=femmodel.parameters.CmMax;

%set current configuration
if isstokes,
	femmodel=SetCurrentConfiguration(femmodel,DiagnsoticStokesAnalysisEnum);
else
	femmodel=SetCurrentConfiguration(femmodel,DiagnosticHorizAnalysisEnum);
end

%Use ControlParameterEnum input to  reinitialize our input parameter:
femmodel.elements=InputDuplicate(femmodel.elements,femmodel.nodes,femmodel.vertices,femmodel.loads,femmodel.materials,femmodel.parameters,ControlParameterEnum,control_type);

%Use search scalar to shoot parameter in the gradient direction:
scalar=search_scalar*optscal;
[femmodel.elements femmodel.materials]=InputAXPY(femmodel.elements,femmodel.nodes,femmodel.vertices,femmodel.loads,femmodel.materials,femmodel.parameters,control_type,scalar,GradientEnum);

%Constrain:
[femmodel.elements,femmodel.nodes,femmmodel.vertices,femmodel.loads,femmodel.materials,femmodel.parameters]=InputControlConstrain(femmodel.elements,femmodel.nodes,femmodel.vertices,femmodel.loads,femmodel.materials,femmodel.parameters,control_type,cm_min,cm_max);

%Run diagnostic with updated inputs:
if(control_steady==0),
	femmodel=solver_diagnostic_nonlinear(femmodel,conserve_loads);  %true means we conserve loads at each diagnostic run
else
	femmodel=diagnostic_core(femmodel);  %We need a 3D velocity!! (vz is required for the next thermal run)
end

%Compute misfit for this velocity field
[femmodel.elements,femmodel.loads]=InputUpdateFromConstant(femmodel.elements,femmodel.nodes,femmodel.vertices, femmodel.loads,femmodel.materials,femmodel.parameters,fit,FitEnum);
J=CostFunction(femmodel.elements,femmodel.nodes,femmodel.vertices,femmodel.loads,femmodel.materials, femmodel.parameters);
